function Create(self)
	self.presstimer = Timer();
	self.count=0;
	self.OriginalName=self.PresetName;
	self.GunName="ISME Bindweed IA";
	self.broken=false;
	self.binded=false;
	self.Power=50;
	--self.ShowSettings=false;
	self.NoWeaponTimer=0;
	self.mode=1;
	self.LastGoodMode=1;
	

	local partcurdist = 40;
	for pix in MovableMan.Particles do
		if string.find(pix.PresetName,self.OriginalName)~=nil then
			local Dist=SceneMan:ShortestDistance(pix.Pos,self.Pos,true);
			if (Dist.Magnitude < partcurdist) then
				self.count=self.count+1;
				if self.count>1 then
					self.ToDelete = true;
					break;
				end
			end
		end
	end
	if self.count==1 then
		DefaultSettings(self);
		if self.Power>100 or self.Power<0 then
			self.Power=50;
		end
		if self.mode>3 or self.mode<1 then
			self.mode=1;
		end
		self.Vel.X=0.01;
		self.Vel.Y=self.mode/100;
		self.Mass=self.Power/100;
		if BindToAHuman(self)==false then
			if BindToHDFirearm(self)==false then
				--self.ToDelete = true;
			else
				--CreateIndicators (self,self.gun);
			end
		else
			CreateIndicators (self,self.origin);
		end
	else
		--self.ToDelete = true;
	end
end
 
function Update(self)
		if self.presstimer:IsPastSimMS(400) == true then
			self.presstimer:Reset();
			self.presses = 0;
			self.pressed = false;
		end
		
		if (MovableMan:ValidMO(self.origin)==false) and (MovableMan:ValidMO(self.gun)==false) and (self.ToDelete == false) then
			if BindToAHuman(self)==false then
				if BindToHDFirearm(self)==false then
					--if self.selfdestructiontime~=0 then
							--self.ToDelete=true;
					--end
				else
					--CreateIndicators (self,self.gun);
				end
			else
				CreateIndicators (self,self.origin);
			end
		end
		
		if (MovableMan:ValidMO(self.origin)==true) and (MovableMan:ValidMO(self.gun)==false) then
			
			SelfKeepAliveAndWell(self);
			
			self.origin:GetController():SetState(Controller.WEAPON_CHANGE_NEXT,false);--Disable weapon changing on scroll
			self.origin:GetController():SetState(Controller.WEAPON_CHANGE_PREV,false);--
			
			ProcessUserInput(self);
			UpdateIndicators(self);
				
			if (self.mode==3) and (self.origin:GetController():IsState(Controller.WEAPON_FIRE)==true) then
				local desdist = (30+60*self.Mass);
				for pix in MovableMan.Particles do
					if (pix.PresetName ~= "CompressedPlasmaCellIA") and (pix.PresetName ~= nil) and (pix.HitsMOs) and (pix.Sharpness>8) then
						local Distance=SceneMan:ShortestDistance(pix.Pos,self.origin.Pos,true);
						if Distance.Magnitude<desdist then
							pix.Sharpness=pix.Sharpness*(1-self.Vel.X); 
							pix.Vel=pix.Vel*(1-self.Vel.X);
							pix.Mass=pix.Mass*0.9;
						end
					end
				end
			end
			if self.origin:HasObject(self.GunName) then
				if (self.WeaponInHand==false) and (self.origin:GetController():IsState(Controller.PIE_MENU_ACTIVE)==false) then
					local partcurdist = 20;
					for pix in MovableMan.Particles do
						if (pix.ClassName == "MOPixel") and (pix.PresetName=="BindweedInHandIndicatorIA") then
							local Dist=SceneMan:ShortestDistance(pix.Pos,self.Pos,true);
							if (Dist.Magnitude < partcurdist) then			
								self.WeaponInHand=true;
							end
						end
					end
				end
			else
				if (MovableMan:ValidMO(self.ModeIndicator)==true) then
					self.ModeIndicator.ToDelete = true;
				end
				if (MovableMan:ValidMO(self.PowerIndicator)==true) then
					self.PowerIndicator.ToDelete = true;
				end
				if BindToHDFirearm (self)== false then
					self.origin=nil;
				else
				end
				--if self.Age-self.NoWeaponTimer>5000 then
				--	self.ToDelete = true;
				--end
			end
		end
		if (MovableMan:ValidMO(self.origin)==false) and (MovableMan:ValidMO(self.gun)==true) then
		SelfKeepAliveAndWell(self);
			if BindToAHuman(self)==false then
			else
				CreateIndicators (self,self.origin);
			end
		end	
end

function Destroy(self)
	if	(MovableMan:ValidMO(self.ModeIndicator)==true) then
		self.ModeIndicator.ToDelete = true;
	end
	if (MovableMan:ValidMO(self.PowerIndicator)==true) then
		self.PowerIndicator.ToDelete = true;
	end
end