function Create(self)
	self.time = 1;
	self.light = 0;
	self.safe = 45;
	self.precision=2;
	self.flicker=false;
	self.FocusMin=70;
	self.FocusSpan=60;
	
	self.MinSphereRadius=30;
	self.SphereRadiusSpan=30;
	
	self.flag=false;
	local curdist = 40;
	for actor in MovableMan.Actors do
		if (actor.ClassName == "AHuman") and (actor:HasObject("ISME Bindweed IA")) then
			local Dist=SceneMan:ShortestDistance(actor.Pos,self.Pos,true);
			if Dist.Magnitude < curdist then
				curdist = Dist.Magnitude;
				self.origin = actor;
				--self.CharHeight=actor.CharHeight;
				--print(self.CharHeight);
			end
		end
	end
	
	if self.origin~=nil then
		local name="BindweedControllerIA"..self.origin.ID;
		for pix in MovableMan.Particles do
			if (pix.PresetName==name) then
				self.controller = pix;
				self.mode = math.ceil(pix.Vel.Y*100);
			end
		end	
	end
	
	if (self.origin==nil) or (self.controller==nil) then 
		self.ToDelete = true;
		self.mode = 0;
		self.time = 0;
	else
		self.origin.aimangle = self.origin:GetAimAngle(true);
		if self.mode==nil then
			self.mode=0;
		end
		if self.mode == 1 then 
			if PlasmaStreamHitsPlayer(self)==false then
				self:SetWhichMOToNotHit(self.origin,-1);
			end
			self.maxrange=500; 
			self.Sharpness=90+(100*(1-self.controller.Mass));
			self.Lifetime=1800;
			self.FocusDist=self.FocusMin+self.FocusSpan*self.controller.Mass;
		end
		if self.mode == 2 then
			if PlasmaStreamHitsPlayer(self)==false then
				self:SetWhichMOToNotHit(self.origin,-1);
			end
			self.maxrange=self.safe*1.6+290*(1-self.controller.Mass);
			--self.Sharpness=350;
			self.Sharpness=100+1000*self.controller.Mass
			self.Lifetime=1900;
			self.Mass=self.controller.Mass/3+0.02;
			
			self.time=self.time+1.2;
		end
		if self.mode == 3 then
			if PlasmaStreamHitsPlayer(self)==false then
				self:SetWhichMOToNotHit(self.origin,-1);
			end
			self.Lifetime=870;
			self.maxrange=110;
			self.time=self.time+1;
			self.SphereRadius=self.MinSphereRadius+self.SphereRadiusSpan*self.controller.Mass;
			self.controller.Vel.X=self.controller.Vel.X+0.01;
		--	print(self.EffectStopTime);
		--	print(self.ScreenEffect.EffectStopTime);
		--	print(self.ScreenEffect.StopTime);
		--	self.EffectStopTime=8000
			self.Sharpness=80;
		end
		if self.mode >10  then
			self.Sharpness=math.random(50);
			self.Lifetime=math.random(200);
			self.maxrange= math.random(150);
			self.safe=math.random(150);
			self.FocusDist=math.random(150);
			self.mode=math.ceil(math.random(2));
			self.time=math.random(3);
		end
	end
	
end
	

	
function Update(self)
if self.Age%self.precision~=0 then
	if (MovableMan:ValidMO(self.origin)) and (MovableMan:ValidMO(self.controller)) then
	
		self.dist=SceneMan:ShortestDistance(self.origin.Pos,self.Pos,true);
		
		if (self.dist.Magnitude~=nil) and (self.maxrange~=nil) then
			if self.dist.Magnitude>self.maxrange then												--[[Maximum range for integrity control field]]--
				self.mode =0;
			end
		end
		
		if self.controller.Vel.Y>0.1 then 
			self.mode=0; 
		end
		
		if (self.origin:GetController():IsState(Controller.PRESS_DOWN)==true) then
			self.mode=0;
		end
		
		if (self.origin:GetController():IsState(Controller.WEAPON_FIRE)==true) and (self.mode~=0) and (self.mode~=9) then 
		
			if (self.mode==1) then
				self.FocusDist=self.FocusMin+self.FocusSpan*self.controller.Mass;
				self.origin.aimangle = self.origin:GetAimAngle(true);
				DestX = self.origin.Pos.X+math.cos(self.origin.aimangle)*self.FocusDist;
				DestY =	self.origin.Pos.Y-math.sin(self.origin.aimangle)*self.FocusDist;
				Dest = Vector(DestX,DestY);

				DestVector=SceneMan:ShortestDistance(Dest,self.Pos,true);
				Mag=(DestVector.Magnitude/self.time)*(1/self.precision);
				self.Vel.Y=(self.Vel.Y-DestVector.Y/(Mag*1.3));
				self.Vel.X=(self.Vel.X-DestVector.X/Mag*1.7);
		
				self.light=self.light+1;                                            --Safe to remove if it lags
				if self.light==3 then                                               --
					local pix = CreateMOPixel("CompressedPlasmaCellLight");         --
					pix.Pos=self.Pos;												--
					MovableMan:AddParticle(pix);									--
					self.light = 0;													--
				end	
			end
			
			if (self.mode==2) then
				if self.flag==false then
					if 	((math.abs(self.Vel.X)<3) and (math.abs(self.Vel.Y)<3) and (self.time>3)) then
						self.mode=0;
					end
					local MOIDMat=SceneMan:GetMOIDPixel(self.Pos.X,self.Pos.Y);
					if (MOIDMat~=255) and (self.dist.Magnitude>self.safe) then  
						--print (MOIDMat);
						--print (self.origin.ID);
						self.mode=0;
					end
					
					local DeltaVel=(11*(self.time-1));
					self.Vel.X = math.cos(self.origin.aimangle)*DeltaVel*(2-self.controller.Mass*1.8);
					self.Vel.Y = -math.sin(self.origin.aimangle)*DeltaVel*(2-self.controller.Mass*1.8);
					--if self.Sharpness > self.time*13 then
						--self.Sharpness=self.Sharpness/(self.time-0.9);
						self.time=self.time+(1.1-self.controller.Mass);
						if self.Sharpness>10 then
							self.Sharpness=self.Sharpness-((1-self.controller.Mass*self.controller.Mass)*self.Sharpness);    --+300*self.controller.Mass
						end
						self.Mass=0.02+self.Mass-((1-self.controller.Mass)*self.Mass);
					--else
					--	self.Sharpness=1;
					--end
				end
			end
			
			if (self.mode==3) then
				if self.flag==false then
					self.SphereRadius=self.MinSphereRadius+self.SphereRadiusSpan*self.controller.Mass;
					self.origin.aimangle = self.origin:GetAimAngle(true);
					local DeltaAng=self.Age/160;
					
					--***shield 2D***
					--if self.Age%2==0 then 
					--	DestY =	self.origin.Pos.Y+math.sin(-(self.origin.aimangle+DeltaAng))*self.SphereRadius;  --self.CharHeight ?
					--	DestX = self.origin.Pos.X+math.cos(self.origin.aimangle+DeltaAng)*self.SphereRadius;
					--else
					--	DestY =	self.origin.Pos.Y+math.sin(-(self.origin.aimangle-DeltaAng))*self.SphereRadius;
					--	DestX = self.origin.Pos.X+math.cos(self.origin.aimangle-DeltaAng)*self.SphereRadius;
					--end
					--local Dest = Vector(DestX,DestY);
					--if SceneMan:GetTerrMatter(DestX,DestY) = 0 then
					--	self.Pos=Dest;
					--end;
					--**************
					
					--***shield "3D"***
					--if self.Age%2==0 then 
					---	DestY =	self.origin.Pos.Y-math.sin(-self.Age/500-DeltaAng+3.14)*self.SphereRadius--self.CharHeight;
					--else
					--	DestY =	self.origin.Pos.Y+math.sin(self.Age/1500+DeltaAng)*self.SphereRadius--self.CharHeight;
					--end             
					--	DestX = self.origin.Pos.X+math.cos(self.Age/1500+DeltaAng)*self.SphereRadius;
					--local Dest = Vector(DestX,DestY);
					--if SceneMan:GetTerrMatter(DestX,DestY) = 0 then
					--	self.Pos=Dest;
					--end;
					--**************
					
					--***terrain-aware 2D shield***                                                         --this section may cause some lag on slower mashines (and anyway need optimisation)
					local placed=false;																		--feel free to comment this section and uncomment one of the two above.
					for i=0,self.SphereRadius,10 do						
						if placed==false then														
							if self.flicker==false then
								DestY =	self.origin.Pos.Y+math.sin(-(self.origin.aimangle+DeltaAng))*(i-10); 
								DestX = self.origin.Pos.X+math.cos(self.origin.aimangle+DeltaAng)*(i-10);
							else
								DestY =	self.origin.Pos.Y+math.sin(-(self.origin.aimangle-DeltaAng))*(i-10);
								DestX = self.origin.Pos.X+math.cos(self.origin.aimangle-DeltaAng)*(i-10);
							end
						end
						if SceneMan:GetTerrMatter(DestX,DestY) ~= 0 then
							self.Pos.Y=DestY;
							self.Pos.X=DestX;
							placed=true;
						end
					end
					if placed==false then
						if self.flicker==false then
							DestY =	self.origin.Pos.Y+math.sin(-(self.origin.aimangle+DeltaAng))*self.SphereRadius;
							DestX = self.origin.Pos.X+math.cos(self.origin.aimangle+DeltaAng)*self.SphereRadius;
						else
							DestY =	self.origin.Pos.Y+math.sin(-(self.origin.aimangle-DeltaAng))*self.SphereRadius;
							DestX = self.origin.Pos.X+math.cos(self.origin.aimangle-DeltaAng)*self.SphereRadius;
						end
						self.Pos.Y=DestY;
						self.Pos.X=DestX;
					end
					if self.flicker==true then
						self.flicker=false;
					else
						self.flicker=true;
					end
					--**************																				--LAME code ends here
					
					local MOIDMat=SceneMan:GetMOIDPixel(self.Pos.X,self.Pos.Y);
					if (MOIDMat~=255) then  
						self.Sharpness=70+400*(1-self.controller.Mass);
						self.Mass=1-self.controller.Mass;
						self.GlobalAccScalar=1;
					else 
						self.Sharpness=70;
						self.Mass=0.01;
						self.GlobalAccScalar=0;
					end
		
					self.light=self.light+1;                                            --Safe to remove if it lags
					if self.light==3 then                                               --
						local pix = CreateMOPixel("CompressedPlasmaCellLight");         --
						pix.Pos=self.Pos;												--
						MovableMan:AddParticle(pix);									--
						self.light = 0;													--
					end	
				end
			end
		else
	
			if (self.mode==1) then
				self.mode=9;
			end
	
			if (self.mode==2) then	
				self.flag=true;
				self.Vel=self.Vel;
				--if 	((math.abs(self.Vel.X)<3) and (math.abs(self.Vel.Y)<3)) or (self.time>2) then
				if (self.dist.Magnitude)>self.safe*2 then
					self.mode=0;
				end
				--end
			end
			
			if (self.mode==3) then
				if self.flag==false then
					self.flag=true;
					self.origin.aimangle = self.origin:GetAimAngle(true);
						if (self.controller.Vel.X>0.01) then
							self.controller.Vel.X=self.controller.Vel.X-0.01;
						end
					end
					DestX = self.origin.Pos.X+math.cos(self.origin.aimangle)*self.maxrange;
					DestY =	self.origin.Pos.Y-math.sin(self.origin.aimangle)*self.maxrange;
					Dest = Vector(DestX,DestY);

					DestVector=SceneMan:ShortestDistance(Dest,self.Pos,true);
					Mag=(DestVector.Magnitude/self.time);
					
					self.Vel.Y=self.Vel.Y-DestVector.Y/Mag*3;
					self.Vel.X=self.Vel.X-DestVector.X/Mag*3;
					
					local MOIDMat=SceneMan:GetMOIDPixel(self.Pos.X,self.Pos.Y);
					if (MOIDMat~=255) and (self.dist.Magnitude>self.safe*1.5) then  
						self.mode=0;
					end

				--self.Vel.Y=self.Vel.Y-DestVector.Y/(Mag/3);
				--self.Vel.X=self.Vel.X-DestVector.X/(Mag/3);
				end
			end
	
			if (self.mode==9) then
				if 	((math.abs(self.Vel.X)<3) and (math.abs(self.Vel.Y)<3) and (self.time>3)) then
						self.mode=0;
					end
				self.Vel.X=self.Vel.X/1.05;
			end
		
			if self.mode==0 then	
				self.Vel.X=self.Vel.X/1.05;	
				if (self.dist.Magnitude)>self.safe then											--safety check 
				local decomp=nil;
				--if (UInputMan:KeyHeld(6)==false) then
					if (self.time<2) and (self.time>=1)then
						decomp = CreateMOSRotating("DecompressionLarge");
						decomp.Pos=self.Pos;
					end 
					if (self.time>=2) and (self.time<=3) then
						decomp = CreateMOSRotating("Decompression");
						decomp.Pos=self.Pos;
					end
					if (self.time>3) and (self.time<10) then
						decomp = CreateMOSRotating("DecompressionSmall");
						decomp.Pos=self.Pos;
					end
					if (self.time>=10) then
						decomp = CreateMOSRotating("DecompressionTiny");
						decomp.Pos=self.Pos;	
					end
					if (self.time<1) then
						decomp = CreateMOSRotating("DecompressionHuge");
						decomp.Pos=self.Pos;			
					end
					MovableMan:AddParticle(decomp);
					self.ToDelete = true;
				--end
				end
		
			end
	
	else											
		self.ToDelete = true;														--[[Instant decompression if actor is dead]]--
		local decomp = CreateMOSRotating("Decompression");
		decomp.Pos=self.Pos;
		MovableMan:AddParticle(decomp);
	end

self.time = self.time+0.02;
end
end

function Destroy(self)
if (MovableMan:ValidMO(self.origin)) and (MovableMan:ValidMO(self.controller)) then
	if (self.mode==3) then
		if self.flag==false then
			self.flag=true;
			if (self.controller.Vel.X>0.01) then
				self.controller.Vel.X=self.controller.Vel.X-0.01;
			end
		end
	end
end
	--print(self.time);
end